regina::PlugTriSolidTorus Class Reference
Standard Triangulations and Subcomplexes

Represents a plugged triangular solid torus component of a triangulation. More...

`#include <subcomplex/plugtrisolidtorus.h>`

Inheritance diagram for regina::PlugTriSolidTorus:

## Public Member Functions

virtual | ~PlugTriSolidTorus ()
| Destroys this plugged solid torus; note that the corresponding triangular solid torus and layered chains will also be destroyed. More...
PlugTriSolidTorus * | clone () const
| Returns a newly created clone of this structure. More...
const TriSolidTorus & | core () const
| Returns the triangular solid torus at the core of this triangulation. More...
const LayeredChain * | chain (int annulus) const
| Returns the layered chain attached to the requested annulus on the boundary of the core triangular solid torus. More...
int | chainType (int annulus) const
| Returns the way in which a layered chain is attached to the requested annulus on the boundary of the core triangular solid torus. More...
int | equatorType () const
| Returns which types of edges form the equator of the plug. More...
Manifold * | manifold () const
| Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the name of this triangulation as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the name of this triangulation in TeX format to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | name () const
| Returns the name of this specific triangulation as a human-readable string. More...
std::string | TeXName () const
| Returns the name of this specific triangulation in TeX format. More...
virtual AbelianGroup * | homology () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the expected first homology group of this triangulation, if such a routine has been implemented. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Static Public Member Functions

static PlugTriSolidTorus * | isPlugTriSolidTorus (Component< 3 > *comp)
| Determines if the given triangulation component is a plugged triangular solid torus. More...
static StandardTriangulation * | isStandardTriangulation (Component< 3 > *component)
| Determines whether the given component represents one of the standard triangulations understood by Regina. More...
static StandardTriangulation * | isStandardTriangulation (Triangulation< 3 > *tri)
| Determines whether the given triangulation represents one of the standard triangulations understood by Regina. More...

## Static Public Attributes

static const int | CHAIN_NONE
| Indicates an annulus on the triangular solid torus boundary with no attached layered chain. More...
static const int | CHAIN_MAJOR
| Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the major edge of the annulus. More...
static const int | CHAIN_MINOR
| Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the minor edge of the annulus. More...
static const int | EQUATOR_MAJOR
| Indicates that, if no layered chains were present, the equator of the plug would consist of major edges of the core triangular solid torus. More...
static const int | EQUATOR_MINOR
| Indicates that, if no layered chains were present, the equator of the plug would consist of minor edges of the core triangular solid torus. More...

## Detailed Description

Represents a plugged triangular solid torus component of a triangulation.

Such a component is obtained as follows.

Begin with a three-tetrahedron triangular solid torus (as described by class TriSolidTorus). Observe that the three axis edges divide the boundary into three annuli.

To each of these annuli a layered chain may be optionally attached. If present, the chain should be attached so its hinge edges are identified with the axis edges of the corresonding annulus and its bottom tetrahedron is layered over either the major edge or minor edge of the corresponding annulus. The top two triangular faces of the layered chain should remain free.

Thus we now have three annuli on the boundary, each represented as a square two of whose (opposite) edges are axis edges of the original triangular solid torus (and possibly also hinge edges of a layered chain).

Create a plug by gluing two tetrahedra together along a single triangle. The six edges that do not run along this common triangle split the plug boundary into three squares. These three squares must be glued to the three boundary annuli previously described. Each axis edge meets two of the annuli; the two corresponding edges of the plug must be non-adjacent (have no common vertex) on the plug. In this way each of the six edges of the plug not running along its interior triangle corresponds to precisely one of the two instances of precisely one of the three axis edges.

If the axis edges are directed so that they all point the same way around the triangular solid torus, these axis edges when drawn on the plug must all point from one common tip of the plug to the other (where the tips of the plug are the vertices not meeting the interior triangle). The gluings must also be made so that the resulting triangulation component is orientable.

Of the optional StandardTriangulation routines, manifold() is implemented for most plugged triangular solid tori and homology() is not implemented at all.

## Constructor & Destructor Documentation

## ~PlugTriSolidTorus()

virtual regina::PlugTriSolidTorus::~PlugTriSolidTorus | ( |  | ) |

virtual

Destroys this plugged solid torus; note that the corresponding triangular solid torus and layered chains will also be destroyed.

## Member Function Documentation

## chain()

const LayeredChain * regina::PlugTriSolidTorus::chain | ( | int | annulus | ) | const

inline

Returns the layered chain attached to the requested annulus on the boundary of the core triangular solid torus.

If there is no attached layered chain, `null` will be returned.

Note that the core triangular solid torus will be attached to the bottom (as opposed to the top) of the layered chain.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2.

Returns
  the corresponding layered chain.

## chainType()

int regina::PlugTriSolidTorus::chainType | ( | int | annulus | ) | const

inline

Returns the way in which a layered chain is attached to the requested annulus on the boundary of the core triangular solid torus.

This will be one of the chain type constants defined in this class.

Parameters

  annulus | specifies which annulus to examine; this must be 0, 1 or 2.

Returns
  the type of layered chain, or CHAIN_NONE if there is no layered chain attached to the requested annulus.

## clone()

PlugTriSolidTorus* regina::PlugTriSolidTorus::clone | ( |  | ) | const

Returns a newly created clone of this structure.

Returns
  a newly created clone.

## core()

const TriSolidTorus & regina::PlugTriSolidTorus::core | ( |  | ) | const

inline

Returns the triangular solid torus at the core of this triangulation.

Returns
  the core triangular solid torus.

## detail()

std::string regina::Output< StandardTriangulation , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## equatorType()

int regina::PlugTriSolidTorus::equatorType | ( |  | ) | const

inline

Returns which types of edges form the equator of the plug.

In the absence of layered chains these will either all be major edges or all be minor edges.

Layered chains complicate matters, but the roles that the major and minor edges play on the boundary annuli of the triangular solid torus can be carried up to the annuli at the top of each layered chain; the edges filling the corresponding major or minor roles will then form the equator of the plug.

Returns
  the types of edges that form the equator of the plug; this will be one of the equator type constants defined in this class.

## homology()

AbelianGroup * regina::StandardTriangulation::homology | ( |  | ) | const

inline virtual inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homologyH1() (a name that is more specific, but a little longer to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented in regina::LayeredSolidTorus, regina::TriSolidTorus, regina::LayeredChain, regina::SpiralSolidTorus, regina::LayeredTorusBundle, regina::SnapPeaCensusTri, regina::LayeredLensSpace, regina::SnappedBall, regina::LayeredLoop, regina::TrivialTri, regina::L31Pillow, and regina::LayeredChainPair.

## homologyH1()

AbelianGroup * regina::StandardTriangulation::homologyH1 | ( |  | ) | const

inline inherited

Returns the expected first homology group of this triangulation, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this triangulation then this routine will return 0.

This routine does not work by calling Triangulation<3>::homology() on the associated real triangulation. Instead the homology is calculated directly from the known properties of this standard triangulation.

The details of which standard triangulations have homology calculation routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

If this StandardTriangulation describes an entire Triangulation<3> (and not just a part thereof) then the results of this routine should be identical to the homology group obtained by calling Triangulation<3>::homology() upon the associated real triangulation.

This routine can also be accessed via the alias homology() (a name that is less specific, but a little easier to type).

Returns
  the first homology group of this triangulation, or 0 if the appropriate calculation routine has not yet been implemented.

## isPlugTriSolidTorus()

static PlugTriSolidTorus* regina::PlugTriSolidTorus::isPlugTriSolidTorus | ( | Component< 3 > * | comp | ) |

static

Determines if the given triangulation component is a plugged triangular solid torus.

Parameters

  comp | the triangulation component to examine.

Returns
  a newly created structure containing details of the plugged triangular solid torus, or `null` if the given component is not a plugged triangular solid torus.

## isStandardTriangulation() [1/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Component< 3 > * | component | ) |

static inherited

Determines whether the given component represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given component must have the same corresponding boundary triangles, i.e., the component cannot have any further identifications of these boundary triangles with each other.

Note that the triangulation-based routine isStandardTriangulation(Triangulation<3>*) may recognise more triangulations than this routine, since passing an entire triangulation allows access to more information.

Parameters

  component | the triangulation component under examination.

Returns
  the details of the standard triangulation if the given component is recognised, or 0 otherwise.

## isStandardTriangulation() [2/2]

static StandardTriangulation* regina::StandardTriangulation::isStandardTriangulation | ( | Triangulation< 3 > * | tri | ) |

static inherited

Determines whether the given triangulation represents one of the standard triangulations understood by Regina.

The list of recognised triangulations is expected to grow between releases.

If the standard triangulation returned has boundary triangles then the given triangulation must have the same corresponding boundary triangles, i.e., the triangulation cannot have any further identifications of these boundary triangles with each other.

This routine may recognise more triangulations than the component-based isStandardTriangulation(Component<3>*), since passing an entire triangulation allows access to more information.

Parameters

  tri | the triangulation under examination.

Returns
  the details of the standard triangualation if the given triangulation is recognised, or 0 otherwise.

## manifold()

Manifold* regina::PlugTriSolidTorus::manifold | ( |  | ) | const

virtual

Returns the 3-manifold represented by this triangulation, if such a recognition routine has been implemented.

If the 3-manifold cannot be recognised then this routine will return 0.

The details of which standard triangulations have 3-manifold recognition routines can be found in the notes for the corresponding subclasses of StandardTriangulation. The default implementation of this routine returns 0.

It is expected that the number of triangulations whose underlying 3-manifolds can be recognised will grow between releases.

The 3-manifold will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the underlying 3-manifold.

Reimplemented from regina::StandardTriangulation.

## name()

std::string regina::StandardTriangulation::name | ( |  | ) | const

inherited

Returns the name of this specific triangulation as a human-readable string.

Returns
  the name of this triangulation.

## str()

std::string regina::Output< StandardTriangulation , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## TeXName()

std::string regina::StandardTriangulation::TeXName | ( |  | ) | const

inherited

Returns the name of this specific triangulation in TeX format.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Returns
  the name of this triangulation in TeX format.

## utf8()

std::string regina::Output< StandardTriangulation , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeName()

std::ostream& regina::PlugTriSolidTorus::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTeXName()

std::ostream& regina::PlugTriSolidTorus::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the name of this triangulation in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::StandardTriangulation.

## writeTextLong()

void regina::PlugTriSolidTorus::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes a detailed text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::StandardTriangulation.

## writeTextShort()

void regina::StandardTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes a short text representation of this object to the given output stream.

This may be reimplemented by subclasses, but the parent StandardTriangulation class offers a reasonable default implementation based on writeName().

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## Member Data Documentation

## CHAIN_MAJOR

const int regina::PlugTriSolidTorus::CHAIN_MAJOR

static

Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the major edge of the annulus.

## CHAIN_MINOR

const int regina::PlugTriSolidTorus::CHAIN_MINOR

static

Indicates an annulus on the triangular solid torus boundary with an attached layered chain layered over the minor edge of the annulus.

## CHAIN_NONE

const int regina::PlugTriSolidTorus::CHAIN_NONE

static

Indicates an annulus on the triangular solid torus boundary with no attached layered chain.

## EQUATOR_MAJOR

const int regina::PlugTriSolidTorus::EQUATOR_MAJOR

static

Indicates that, if no layered chains were present, the equator of the plug would consist of major edges of the core triangular solid torus.

## EQUATOR_MINOR

const int regina::PlugTriSolidTorus::EQUATOR_MINOR

static

Indicates that, if no layered chains were present, the equator of the plug would consist of minor edges of the core triangular solid torus.

The documentation for this class was generated from the following file:

- subcomplex/plugtrisolidtorus.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).